import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Image;
import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.Display;
import javax.microedition.lcdui.game.GameCanvas;

import lx.interaction.dollar.*;

class HelloDollarCanvas extends GameCanvas implements Runnable, DollarListener
{			
	Dollar dollar = new Dollar(Dollar.GESTURES_DEFAULT); 
	
	protected volatile boolean active = true;	
	int frameDelay = 20;
	
	Image image;	
	
	MIDlet midlet;
	
	public HelloDollarCanvas(MIDlet m) 
	{	
		super(false);
		setFullScreenMode(true);
		midlet = m;
				
		try 
		{	
			image = Image.createImage("/gestures.png"); 
		}
		catch (Exception e) 
		{ 
			System.err.println("HelloDollarCanvas (constructor): Couldn't load image gestures.png, make sure that it is placed in the 'res' folder!");
		}
				
		dollar.setActive(true);
		
		Thread t = new Thread(this);
		t.start(); //schedules run() to start immediately
	}

	protected void keyReleased(int keyCode)
	{
		switch (keyCode)
		{
			case KEY_NUM0:	quit(); break;
		}
		
		switch (getGameAction(keyCode))
		{
			case UP: setFullScreenMode(true); break;
			case DOWN: setFullScreenMode(false); break;
			case FIRE: dollar.clear(); break;
		}
	}
	
	public void dollarDetected(Dollar dollar)
	{
		
	}	
	
	protected void render(Graphics g) 
	{
		g.setColor(0x000000);
		g.fillRect(0, 0, getWidth(), getHeight());
		
	    g.drawImage (image, getWidth (), getHeight (), Graphics.BOTTOM | Graphics.RIGHT);
		
		g.setColor(0x00ff00);			
		
		dollar.render(g);
	
		g.setColor(0x666666);		
				
		text( "Dollar Gesture Recognizer", 10, 10, g);								
		text( "J2ME version by Alex Olwal 2008 (olwal.com)", 10, 30, g);								

		g.setColor(0x00ff00);		

		text( dollar.getName() + " [" + dollar.getScore() + "]", 10, 50, g);
								
		flushGraphics();				
	}
	
	protected void pointerDragged(int x, int y)
	{
		dollar.pointerDragged(x, y);
	}	
	
	protected void pointerReleased(int x, int y)
	{
		dollar.pointerReleased(x, y);
	}

	protected void pointerPressed(int x, int y)
	{
		dollar.pointerPressed(x, y);
	}
	
	public void quit()
	{
		active = false;
		midlet.notifyDestroyed();
	}
	
	public void run() 
	{
		Graphics g = getGraphics();
		g.setFont( Font.getFont(Font.FACE_SYSTEM, Font.STYLE_PLAIN, Font.SIZE_SMALL) );
		
		while (active) 
		{
			render(g);
	
			try { Thread.sleep(frameDelay); }
			catch (InterruptedException ie) { quit(); }
		}
	}	
		
	public static void text(String text, int tx, int ty, Graphics g)
	{	g.drawString( text, tx, ty, Graphics.LEFT | Graphics.TOP);	}	
}

public class HelloDollar extends MIDlet
{
	private HelloDollarCanvas canvas;
	
	public void startApp() 
	{				
		if (canvas == null) 
			canvas = new HelloDollarCanvas(this);
	
		Display.getDisplay(this).setCurrent(canvas);
	}

	public void pauseApp() 
	{
		
	}
	
	public void destroyApp(boolean unconditional) 
	{
		canvas.quit();
	}
}